﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
'Custom View class 
''#Event: ExampleEvent (Value As Int)
''#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
''#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
''#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
''#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
''#DesignerProperty: Key: ColorExample, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
''#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
#DesignerProperty: Key: Hint, DisplayName: Hint text, FieldType: String, DefaultValue: Hint, Description: Hint text
#DesignerProperty: Key: HintTextColor, DisplayName: Hint color, FieldType: Color, DefaultValue: 0xFFCCCCCC, Description: hint label text color
#DesignerProperty: Key: AutoSizeText, DisplayName: AutoSizeText, FieldType: Boolean, DefaultValue: True, Description: Auto size the text to fit the EditText.
#DesignerProperty: Key: Suggestions, DisplayName: Suggestions, FieldType: Boolean, DefaultValue: True, Description: Sets if keyboard suggestions should be visible.
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	Private Const DefaultColorConstant As Int = -984833 'ignore
	Private MyEditText As EditText
	Private LabelHint As Label
	
	Private mStringUtils As StringUtils
	Private mLabelHintMaxHeight As Int
	Private mAutoSizeText As Boolean
	
	Private mSuggestions As Boolean
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	MyEditText.Initialize("MyEditText")
	LabelHint.Initialize("LabelHint")
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	
	MyEditText.Text = Lbl.Text
	MyEditText.TextColor = Lbl.TextColor
	mAutoSizeText = Props.Get("AutoSizeText")
	MyEditText.Gravity = Lbl.Gravity
	MyEditText.Typeface = Lbl.Typeface
	MyEditText.Color = Colors.Transparent
		
	LabelHint.Color = Colors.Transparent
	LabelHint.TextColor = Colors.Gray
		
	If Props.ContainsKey("Hint") Then
		MyEditText.Hint = Props.Get("Hint")
		LabelHint.Text = Props.Get("Hint")
	Else
		LabelHint.Text = "cavolo"
		MyEditText.Hint = "cavolo"
	End If
	If Props.ContainsKey("HintTextColor") Then
		LabelHint.TextColor = Props.Get("HintTextColor")
	Else
		LabelHint.TextColor = DefaultColorConstant
	End If
	
	Dim MyEditTextPercHeight As Float = 0.67
	Dim MyEditTextHeight As Int = Base.Height * MyEditTextPercHeight
	Dim LabelHintPercHeight As Float = 1 - MyEditTextPercHeight
	mLabelHintMaxHeight = Base.Height * LabelHintPercHeight
	
	mBase.AddView(MyEditText, 0, mLabelHintMaxHeight, Base.Width, MyEditTextHeight)
	mBase.AddView(LabelHint, 0, 0, mBase.Width, mLabelHintMaxHeight)
	
	Base.Color = Colors.Transparent

	MyEditText.TextSize = Lbl.TextSize
	AdjustTextSizes
	LabelHint.SetLayout(LabelHint.Left, LabelHint.Top, 0, 0)

'	LabelHint.TextSize = CalculateTextSizeToFit(LabelHint, "Aj")
'	If mAutoSizeText Then
'		MyEditText.TextSize = CalculateTextSizeToFit(MyEditText, "Aj")
'	Else
'		MyEditText.TextSize = Lbl.TextSize
'	End If
'	MyEditText.Color = Colors.White
	mSuggestions = Props.Get("Suggestions")
	SetSugg(MyEditText, mSuggestions)
End Sub

Private Sub AdjustTextSizes
	LabelHint.TextSize = CalculateTextSizeToFit(LabelHint, "Aj")
	If mAutoSizeText Then
		MyEditText.TextSize = CalculateTextSizeToFit(MyEditText, "Aj")
	End If
	MyEditText.Color = Colors.White
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

Public Sub getHintLabel As Label
	Return LabelHint
End Sub
Public Sub getEditText As EditText
	Return MyEditText
End Sub

Public Sub setHint(Hint As String)
	LabelHint.Text = Hint
End Sub
Public Sub getHint As String
	Return LabelHint.Text
End Sub

Public Sub setTextSize(TextSize As Float)
	MyEditText.TextSize = TextSize
End Sub
Public Sub getTextSize As Float
	Return MyEditText.TextSize
End Sub

Public Sub setSuggestions(On As Boolean)
	mSuggestions = On
	SetSugg(MyEditText, On)
End Sub
Public Sub getSuggestions As Boolean
	Return mSuggestions
End Sub

Private Sub MyEditText_TextChanged (Old As String, New As String)
	AnimHintLabel(New.Length > 0)
End Sub

Private Sub AnimHintLabel(Visible As Boolean)
	If Visible Then
		LabelHint.SetLayoutAnimated(300, LabelHint.Left, LabelHint.Top, mBase.Width, mLabelHintMaxHeight)
	Else
		LabelHint.SetLayoutAnimated(300, LabelHint.Left, LabelHint.Top, 0, 0)
	End If
End Sub

Private Sub CalculateTextSizeToFit(lbl As Label, txt As String) As Float
	Dim Result As Float

	Dim dt As Float
	Dim limit = 0.5 As Float
	Dim h As Int
	Dim TopPadding As Int
	Dim BottomPadding As Int
	Dim HiddenLabelPart As Int
	Dim TotalToExclude As Int

	If lbl Is Label Then
		Dim lblFake As Label
		lblFake.Initialize("")
		mBase.AddView(lblFake, 0, 0, lbl.Width, lbl.Height)
		lblFake.Visible = False

		TopPadding = getPaddingTop(lblFake)
		BottomPadding = getPaddingBottom(lblFake)
		HiddenLabelPart = 0
	Else
		Dim etFake As EditText
		etFake.Initialize("")
		mBase.AddView(etFake, 0, 0, lbl.Width, lbl.Height)
		etFake.Visible = False

		TopPadding = getPaddingTop(etFake)
		BottomPadding = getPaddingBottom(etFake)
		HiddenLabelPart = etFake.Height * .15
	End If
	
	TotalToExclude = TopPadding + BottomPadding - HiddenLabelPart

	If lbl Is Label Then
		lblFake.Text = txt
		lblFake.TextSize = 72
		dt = lblFake.TextSize
		h = mStringUtils.MeasureMultilineTextHeight(lblFake, txt) + TotalToExclude
		Do While dt > limit Or h > lblFake.Height
			dt = dt / 2
			h = mStringUtils.MeasureMultilineTextHeight(lblFake, txt) + TotalToExclude
			If h > lblFake.Height Then
				lblFake.TextSize = lblFake.TextSize - dt
			Else
				lblFake.TextSize = lblFake.TextSize + dt
			End If
		Loop
	
		Result = lblFake.TextSize
		lblFake.RemoveView
	Else
		etFake.Text = txt
		etFake.TextSize = 72
		dt = etFake.TextSize
		h = mStringUtils.MeasureMultilineTextHeight(etFake, txt) + TotalToExclude
		Do While dt > limit Or h > etFake.Height
			dt = dt / 2
			h = mStringUtils.MeasureMultilineTextHeight(etFake, txt) + TotalToExclude
			If h > etFake.Height Then
				etFake.TextSize = etFake.TextSize - dt
			Else
				etFake.TextSize = etFake.TextSize + dt
			End If
		Loop
		
		Result = etFake.TextSize
		etFake.RemoveView
	End If
	
	Return Result
End Sub

'Gets the Top padding of the given view
Private Sub getPaddingTop(v As View) As Int
	Dim jo = v As JavaObject
	Return jo.RunMethod("getPaddingTop", Null)
End Sub

'Gets the Bottom padding of the given view
Private Sub getPaddingBottom(v As View) As Int
	Dim jo = v As JavaObject
	Return jo.RunMethod("getPaddingBottom", Null)
End Sub

Private Sub SetSugg(et As EditText, Enable As Boolean)
	If Enable Then
		et.InputType = Bit.And(et.InputType, Bit.Not(145))
	Else
		et.inputType=Bit.Or(et.InputType, 145)
	End If
End Sub